% function performing the ratio test:
% r  =  [(u_{h} - u_{h/2}) / (u_{h/2} - u_{h/4}), 
%        (u_{h/2} - u_{h/4}) / (u_{h/4} - u_{h/8}),
%        (u_{h/4} - u_{h/8}) / (u_{h/8} - u_{h/16}), ...
% If the order of convergence is \alpha, then r(i) -> 2^\alpha
function r = testRatio(meth, h0, tt, ndiv)
    [t2, y2] = meth(h0);
    [t3, y3] = meth(h0/2);
    
    h = h0;
    r = [];
    for i=3:ndiv    
        t1 = t2; y1 = y2;
        t2 = t3; y2 = y3;
        [t3,y3] = meth(h/4);
        
        i1 = find(t1>=tt,1); i2 = find(t2>=tt,1); i3 = find(t3>=tt,1);
        r1 = norm(y1(i1,:) - y2(i2,:));
        r2 = norm(y2(i2,:) - y3(i3,:));
        rr = r1/r2;
        r = [r, rr];
        
        h = h/2;
    end
end