
beta = 0.25;
gamma = 0.1;
x0 = [0.999, 0.001, 0];
h = 0.1;
t0 = 0;
tmax = 100;

[t,x] = ImplTrap(x0, t0, tmax, h, beta, gamma);

figure(1);
clf;
plot(t,x(:,2));

testRatio(@(h) ImplTrap(x0, t0, tmax, h, beta, gamma), h, 50, 7)

function [t,x] = ImplTrap(x0, t0, tmax,h, beta, gamma)
    t = t0:h:tmax;
    n = length(x0);
    nsteps = floor((tmax-t0)/h)+1;
    
    x = zeros(nsteps, n);

    x(1,:) = x0;
    
    for i=2:nsteps
        x(i,:) = Newton(x(i-1,:)', x(i-1,:)',h, beta, gamma)';
    end
end


function xn1 = Newton(xn, xn10, h, beta, gamma)
           
    eps = 1e-12;
    xn1 = xn10;
    difnorm = 1;
      

    while (difnorm>eps)
        J = [-1 - (beta*h*xn1(2))/2, -(beta*h*xn1(1))/2, 0, (beta*h*xn1(2))/2, -1 + (h*(-gamma + beta*xn1(1)))/2, 0, 0, (gamma*h)/2, -1];
        J = reshape(J,3,3);
        
        G = [xn(1) - xn1(1) + (h*(-(beta*xn(1)*xn(2)) - beta*xn1(1)*xn1(2)))/2.; ...
             xn(2) - xn1(2) + (h*(-(gamma*xn(2)) + beta*xn(1)*xn(2) - gamma*xn1(2) + beta*xn1(1)*xn1(2)))/2.; ...
             xn(3) + (h*(gamma*xn(2) + gamma*xn1(2)))/2. - xn1(3)];
         
        xn1p = xn1 - J \ G;
        
        difnorm = norm(xn1p-xn1);
        xn1 = xn1p;        
    end
end 
   



